<?
// START SESSION
ob_start();
session_start();
error_reporting(0);

header('Content-language: en');
header('Content-Type: text/html; charset=utf-8');

// MAIN INCLUDES
include_once('../inc/vars.php');
include_once('../inc/func.php');
include_once('../inc/actions.php');

function getIsActiveItem($page,$match) { return $page == $match ? " active" : ""; }

include_once('inc/mainMenuBar.php');
$mainMenuBar = "";

// GET PROJECT DATA
$page = isset($_GET['page']) ? $_GET['page'] : "home";

if ($page != "authenticate" && (!(isAdmin() || isModerator()) && (!isset($_GET['item']) || $_GET['item'] != "me"))) {
	pageForward("?page=users&item=me"); die();
}

if (!hasStdLettersOnly($page)) { die("<h1>ERROR 403 FORBIDDEN</h1>"); }
$isUrlSecure = isset($_SERVER['HTTPS']);
$httpsMessage = $isUrlSecure !== TRUE ? "<div class=\"security\">Use HTTPS instead of HTTP if possible.</div>" : "";
if (!isAuthenticated()) { include_once('pages/authenticate.php'); $navigation = ""; $authBox = ""; } else {
	include_once('pages/'.$page.'.php');
	if (isModerator()) {
		$navigation = "
			<div class=\"navItem".getIsActiveItem($page,"home")."\"><a href=\"?page=home\">MainPage</a></div>
			<div class=\"navItem".getIsActiveItem($page,"vars")."\"><a href=\"?page=vars\">Variables</a></div>
			<div class=\"navItem".getIsActiveItem($page,"pages")."\"><a href=\"?page=pages\">Pages</a></div>
			<div class=\"navItem".getIsActiveItem($page,"tables")."\"><a href=\"?page=tables\">Tables</a></div>
			<div class=\"navItem".getIsActiveItem($page,"forms")."\"><a href=\"?page=forms\">Forms</a></div>
			<div class=\"navItem".getIsActiveItem($page,"files")."\"><a href=\"?page=files\">Files</a></div>
			<div class=\"navItem".getIsActiveItem($page,"users")."\"><a href=\"?page=users\">Users</a></div>
			<div class=\"navItem".getIsActiveItem($page,"errors")."\"><a href=\"?page=errors\">Errors</a></div>
		";
	}
	if (isAdmin()) {
		$navigation = "
			<div class=\"navItem".getIsActiveItem($page,"home")."\"><a href=\"?page=home\">MainPage</a></div>
			<div class=\"navItem".getIsActiveItem($page,"vars")."\"><a href=\"?page=vars\">Variables</a></div>
			<div class=\"navItem".getIsActiveItem($page,"design")."\"><a href=\"?page=design\">Design</a></div>
			<div class=\"navItem".getIsActiveItem($page,"pages")."\"><a href=\"?page=pages\">Pages</a></div>
			<div class=\"navItem".getIsActiveItem($page,"tables")."\"><a href=\"?page=tables\">Tables</a></div>
			<div class=\"navItem".getIsActiveItem($page,"forms")."\"><a href=\"?page=forms\">Forms</a></div>
			<div class=\"navItem".getIsActiveItem($page,"files")."\"><a href=\"?page=files\">Files</a></div>
			<div class=\"navItem".getIsActiveItem($page,"users")."\"><a href=\"?page=users\">Users</a></div>
			<div class=\"navItem".getIsActiveItem($page,"errors")."\"><a href=\"?page=errors\">Errors</a></div>
			<div class=\"navItem".getIsActiveItem($page,"backups")."\"><a href=\"?page=backups\">Backups</a></div>
			<div class=\"navItem".getIsActiveItem($page,"updater")."\"><a href=\"?page=updater\">Updater</a></div>
		";
	}
	$authBox = "
		<div style=\"float:right;text-align:right;\">
			Logged in as '".$user['username']."' | 
			<a href=\"?page=users&item=me\">Profile</a> | 
			<a href=\"?page=authenticate&action=logout\">Logout</a>
		</div>
	";
	$mainMenuBar = "";
	if (isAdmin() || isModerator()) {
		$mainMenuBar = "<div id=\"mainMenuBar\">".getMainMenuBar()."</div>";
	}
}
if (!(isset($content['title']) && $content['title'] != "")) { $content['title'] = "MainPage"; }

$info = getJson("info");
$title = $info['cms']['name']." Admin Panel - ".$content['title'];

$wysiwyg = "";
if ($page == "pages") {
	$wysiwyg = "
		<script type=\"text/javascript\" src=\"addons/wysiwyg/tinymce/tinymce.min.js\"></script>
		<script type=\"text/javascript\">
		tinymce.init({
			selector: \"textarea\",
			plugins: [
				\"advlist autolink lists link image charmap print preview anchor\",
				\"searchreplace visualblocks code fullscreen wordcount\",
				\"insertdatetime media table contextmenu paste\"
			],
			toolbar: \"insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image\"
		});
		</script>
	";
}

// SET OUTPUT
$output = "<html>
	<head>
		<title>".$title."</title>
		<link rel=\"stylesheet\" type=\"text/css\" href=\"main.css\">
		<script type=\"text/javascript\" src=\"js/prototype.js\"></script>
		<script type=\"text/javascript\" src=\"js/main.js\"></script>
		<script type=\"text/javascript\" src=\"js/menu.js\"></script>
		".$wysiwyg."
	</head>
	<body>
		<div id=\"body\">
			<div id=\"main\">
				".$httpsMessage."
				".$mainMenuBar."
				<div id=\"head\">
					".$authBox."<div id=\"title\"><h1>".$title."</h1></div>
					<div id=\"navigation\">".$navigation."</div>
				</div>
				<div id=\"content\">".$content['body']."</div>
				<div id=\"footer\">
					System: <b><a href=\"".$info['cms']['url']."\" target=\"_blank\">".$info['cms']['name']."</a></b> 
					| Version: ".$info['cms']['version']." 
					| Licence: ".$info['cms']['licence']."
				</div>
			</div>
		</div>
	</body>
</html>";

// PRINT OUTPUT
die($output);

?>
