<?

$content = array();
$content['title'] = "Forms";
$content['body'] = "";

function isFormAvailable($name) { return jsonExists("forms/".$name); }

$forms = getForms();
$pages = getPages();

function isFormInPage($formName,$pageName) {
	$pageItem = getPage($pageName); return isValid($pageItem['body'],"/(.*?{{form:".$formName."}}.*)/is");
}
function isFormInPages($formName) {
	global $pages; foreach(array_keys($pages) as $p) { if(isFormInPage($formName,$pages[$p])) { return TRUE; } }
	return FALSE;
}

// Forms overview
if (!isset($_GET['item']) && !isset($_GET['action'])) {
	$content['body'] .= "
		With forms your visitors and/or users can interact with your company and/or your online tables.<br>
		Such forms can be included into the <a href=\"?page=pages\">Pages</a> 'body' by {{forms:<em>FORMID</em>}}.<br>
		Use the CSS part in '<a href=\"?page=design\">Design</a>' for styling the forms.
		<br><br>";
	$content['body'] .= "
		<a href=\"?page=".$page."&action=add\">Add a new form</a><br><br>
		<table>
		<tr><td colspan=\"5\"><hr></td></tr>
		<tr>
			<th>Form&nbsp;id&nbsp;&nbsp;&nbsp;</th>
			<th>Form&nbsp;type&nbsp;&nbsp;&nbsp;</th>
			<th>Page&nbsp;connections&nbsp;&nbsp;&nbsp;</th>
			<th>Access for&nbsp;&nbsp;&nbsp;</th>
			<th>Actions</th>
		</tr>
		<tr><td colspan=\"5\"><hr></td></tr>
	";
	foreach(array_keys($forms) as $f) {
		
		$formName = $forms[$f]; $jsonPath = "forms/".$formName; $formItem = getJson($jsonPath);
		$formType = (isset($formItem['mail']) && isset($formItem['mail']['send']) && $formItem['mail']['send'] == "1") ? "Mail" : "";
		$isInPages = isFormInPages($formName); $isInPagesText = ($isInPages === TRUE) ? "isInPages" : "-";
		$removeText = !$isInPages ? "<a href=\"?page=".$page."&item=".$formName."&action=remove\">remove</a>" : "not removable (remove includes in proper pages first)";
		$content['body'] .= "
			<tr>
				<td><a href=\"?page=".$page."&item=".$formName."\">".$formName."</a>&nbsp;&nbsp;&nbsp;</td>
				<td>".$formType."&nbsp;&nbsp;&nbsp;</td>
				<td>".$isInPagesText."&nbsp;&nbsp;&nbsp;</td>
				<td>Everyone&nbsp;&nbsp;&nbsp;</td>
				<td><a href=\"?page=".$page."&item=".$formName."&action=update\">update</a>&nbsp;|&nbsp;".$removeText."</td>
			</tr>";
	}
	$content['body'] .= "<tr><td colspan=\"5\"><hr></td></tr></table>";
	
}

if (isset($_GET['item'])) {
	$item = $_GET['item']; if (!isFormAvailable($item)) { pageForward("?page=".$page); }
	$values = getJson("forms/".$item); $fields = $values['fields'];
}

// Display form
if (isset($_GET['item']) && !isset($_GET['action'])) {
	$formType = (isset($values['mail']) && isset($values['mail']['send']) && $values['mail']['send'] == "1") ? "Mail" : "";
	$fieldsText = "<table><tr><th>Id</th><th>Name</th><th>Type</th><th>Check</th><th>Error message</th></tr>";
	foreach(array_keys($fields) as $f) {
		$fieldsText .= "
			<tr>
				<td>".$f."&nbsp;&nbsp;&nbsp;</td>
				<td>".$fields[$f]['name']."&nbsp;&nbsp;&nbsp;</td>
				<td>".$fields[$f]['type']."&nbsp;&nbsp;&nbsp;</td>
				<td>".$fields[$f]['check']."&nbsp;&nbsp;&nbsp;</td>
				<td>".$fields[$f]['error']."&nbsp;&nbsp;&nbsp;</td>
			</tr>
		";
	}
	$fieldsText .= "</table>";
	$content['body'] .= "
		<div>
			<span>
				<input class=\"submit\" type=\"button\" name=\"goToOverview\" value=\"Go to overview\" onclick=\"loadUrl('?page=".$page."')\">
				&nbsp;&nbsp;
				<input class=\"submit\" type=\"button\" name=\"copyItem\" value=\"Copy that form\" onclick=\"loadUrl('?page=".$page."&action=add&copy=".$item."')\">
				&nbsp;&nbsp;
				<input class=\"submit\" type=\"button\" name=\"updateItem\" value=\"Update this item\" onclick=\"loadUrl('?page=".$page."&item=".$item."&action=update')\">
				&nbsp;&nbsp;
				<input class=\"submit\" type=\"button\" name=\"removeItem\" value=\"Remove this item\" onclick=\"loadUrl('?page=".$page."&item=".$item."&action=remove')\">
			</span>
		</div>
		<div><hr></div>
		<div>
			<span style=\"float: left; width: 100px;\">Id:&nbsp;</span>
			<span>".$item."</span>
		</div>
		<div>
			<span style=\"float: left; width: 100px;\">Title:&nbsp;</span>
			<span>".$values['title']."</span>
		</div>
		<div>
			<span style=\"float: left; width: 100px;\">Action type:&nbsp;</span>
			<span>".$formType."</span>
		</div>
		<div>&nbsp;</div>
		<div>
			<span style=\"float: left; width: 100px;\">Fields:&nbsp;</span>
			<span>".$fieldsText."</span>
		</div>
	";
}

// add,update,remove messages
if (!isset($_GET['item']) && isset($_GET['action'])) {
	$error = isset($_GET['error']) ? $_GET['error'] : "";
	if ($_GET['action'] == "added" && $error == "") { $message = "The form was created successfully."; }
	if ($_GET['action'] == "updated" && $error == "") { $message = "The form was changed successfully."; }
	if ($_GET['action'] == "removed" && $error == "") { $message = "The form was removed successfully."; }
	if (isset($message)) {
		if ($error == "empty") { $message = "FormId cannot be empty."; }
		if ($error == "syntax") { $message = "One or more fields are not well formed."; }
		if ($error == "exist") { $message = "There is already a form with that id."; }
		if ($error == "wrongid") { $message = "Wrong formId."; }
		$link = $error == "" ? "<a href=\"?page=".$page."\">Go to form overview</a>" : "<a href=\"javascript:;\" onClick=\"history:back(-1)\">Try again</a>";
		$content['body'] .= "<div class=\"message\">" . $message . "</div>".$link;
	}
}

/*
function getNewFormStructure($data) {
	$return = array();
	
	// mail data
	if (isset($data['mail'])) {
		$data['mail']['success'] = isset($data['mail']['success']) ? htmlHexChars(stripslashes($data['mail']['success'])) : "";
		$data['mail']['error'] = isset($data['mail']['error']) ? htmlHexChars(stripslashes($data['mail']['error'])) : "";
		
	}
	
	// form fields
	$newFields = $data['fields'];
	foreach($newFields as $n) {
		$newFields[$n]['name'] = isset($newFields[$n]['name']) ? htmlHexChars(stripslashes($newFields[$n]['name'])) : "";
		$newFields[$n]['error'] = isset($newFields[$n]['error']) ? htmlHexChars(stripslashes($newFields[$n]['error'])) : "";
	}
	$return['fields'] = $newFields;
	return $return;
}
*/

// Add form
if (!isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "add") {
	if (isset($_POST['id'])) {
		$formId = $_POST['id'];
		if ($formId == "") { pageForward("?page=".$page."&action=added&error=empty"); }
		if (!hasStdLettersOnly($formId)) { pageForward("?page=".$page."&action=added&error=syntax"); }
		if (isFormAvailable($formId)) { pageForward("?page=".$page."&action=added&error=exist"); }
		$json = $_POST['data']; writeJson("forms/".$formId,$json);
		pageForward("?page=".$page."&action=added");
	}
	$content['body'] .= "
		<form method=\"post\" action=\"\" name=\"addForm\">
			<div>
				<span style=\"float: left; width: 100px;\">Id:&nbsp;</span>
				<span>".getFormField("text","id","")."</span>
			</div>
			<div>
				<span style=\"float: left; width: 100px;\">Title:&nbsp;</span>
				<span>".getFormField("text","data[title]","")."</span>
			</div>
			
			<div><hr></div>
			
			<div>
				<span>Fields:&nbsp;</span>
				<span>
					<div>
						<span>Add a new field: </span>
						<span>
							<input type=\"text\" id=\"addFieldValue\" name=\"addFieldValue\" value=\"\" style=\"width:100px\">
							<input type=\"button\" name=\"addField\" value=\"Add\" style=\"width:50px\" onclick=\"addFormField('addFieldValue');\">
						</span>
					</div>
				</span>
			</div>
			<div id=\"fieldtitles\">
				<span style=\"float: left; width: 100px;\">&nbsp;&nbsp;&nbsp;<b>Id</b></span>
				<span style=\"float: left; width: 150px;\"><b>Display name</b></span>
				<span style=\"float: left; width: 150px;\"><b>Field type</b></span>
				<span style=\"float: left; width: 150px;\"><b>Check statement</b></span>
				<span><b>Message on error</b></span>
			</div>
			<div id=\"fields\"></div>
			<div id=\"submitButtonName\">
				<span style=\"float: left; width: 100px;\"><b>Submit:&nbsp;</b></span>
				<span>".getFormField("text","data[button][submit][name]","Submit")."</span>
			</div>
			<div><hr></div>
			
			<div>
				<span>Mail after submit:&nbsp;</span>
				<span><input id=\"isMail\" class=\"check\" type=\"checkbox\" name=\"data[mail][send]\" value=\"1\" onChange=\"formActionMail()\"></span>
			</div>
			<div id=\"isMailFields\" style=\"visibility:hidden;display:none;\">
				<div>
					<span style=\"float: left; width: 150px;\"> - From:&nbsp;</span>
					<span>".getFormField("text","data[mail][from]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - ReplyTo:&nbsp;</span>
					<span>".getFormField("text","data[mail][reply]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - To:&nbsp;</span>
					<span>".getFormField("text","data[mail][to]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Cc:&nbsp;</span>
					<span>".getFormField("text","data[mail][cc]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Bcc:&nbsp;</span>
					<span>".getFormField("text","data[mail][bcc]","")."</span>
				</div>
				
				<div>
					<span style=\"float: left; width: 150px;\"> - Subject:&nbsp;</span>
					<span>".getFormField("text","data[mail][subject]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Body:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][body]","")."</span>
				</div>
				
				<div>
					<span style=\"float: left; width: 150px;\"> - Success message:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][success]","")."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Error message:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][error]","")."</span>
				</div>
			</div>
			
			<div>&nbsp;</div>
			
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Add form\" onclick=\"submitForm('addForm')\">
				</span>
			</div>
		</form>
	";
}

// Update form
if (isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "update") {
	$item = $_GET['item'];
	if (!isFormAvailable($item)) { pageForward("?page=".$page); }
	if (isset($_POST['id'])) {
		$formId = $_POST['id'];
		if ($formId == "") { pageForward("?page=".$page."&action=updated&error=empty"); }
		if (!hasStdLettersOnly($formId)) { pageForward("?page=".$page."&action=updated&error=syntax"); }
		if ($formId != $item) { pageForward("?page=".$page."&action=updated&error=wrongid"); }
		$json = $_POST['data'];
		foreach($json['fields'] as $k => $v) {
			$json['fields'][$k]['name'] = htmlHexChars($json['fields'][$k]['name']);
			$json['fields'][$k]['check'] = htmlHexChars($json['fields'][$k]['check']);
			$json['fields'][$k]['error'] = htmlHexChars($json['fields'][$k]['error']);
		}
		foreach($json['mail'] as $k => $v) {
			if (!($k == "from" || $k == "to" || $k == "cc" || $k == "bcc")) {
				$json['mail'][$k] = htmlHexChars($json['mail'][$k]);
			}
		}
		$json['onSubmitJS'] = htmlHexChars($json['onSubmitJS']);
		writeJson("forms/".$formId,$json);
		pageForward("?page=".$page."&action=updated");
	}
	$values = getJson("forms/".$item);
	$formFieldsText = "";
	
	foreach(array_keys($values['fields']) as $i) {
		$formFieldsText .= "<div id=\"field[".$i."]\">";
		$formFieldsText .= "<span style=\"float: left; width: 100px;\"> - ".$i."</span>";
		$formFieldsText .= "<span style=\"float: left; width: 150px;\">";
		$formFieldsText .= "<input type=\"text\" name=\"data[fields][".$i."][name]\" value=\"".$values['fields'][$i]['name']."\" style=\"width: 130px;\">";
		$formFieldsText .= "</span>";
		$formFieldsText .= "<span style=\"float: left; width: 150px;\">&nbsp;";
		$formFieldsText .= "<select id=\"field[".$i."][type]\" name=\"data[fields][".$i."][type]\" style=\"width: 100px;\" onChange=\"displayFormCheckField('".$i."',this.options[this.selectedIndex].value)\">";
		$selected = $values['fields'][$i]['type'];
		$formFieldTypes = getFormFieldTypes();
		foreach(array_keys($formFieldTypes) as $t) {
			$isSelectedText = $selected == $t ? " selected=\"selected\"" : "";
			$formFieldsText .= "<option value=\"".$t."\"".$isSelectedText.">".$formFieldTypes[$t]."</option>\n";
		}
		$formFieldsText .= "</select>";
		$formFieldsText .= "</span>";
		$formFieldsText .= "<span id=\"field[".$i."][check]\" style=\"float: left; width: 150px;\">";
		$formFieldsText .= getFormFieldTypeCheck($selected,$values['fields'][$i]['check'],$i);
		$formFieldsText .= "</span>";
		$formFieldsText .= "<span id=\"field[".$i."][error]\">";
		$formFieldsText .= "<input type=\"text\" name=\"data[fields][".$i."][error]\" value=\"".$values['fields'][$i]['error']."\" style=\"width: 230px;\">";
		$formFieldsText .= "</span>";
		$formFieldsText .= "<span>&nbsp;&nbsp;move&nbsp;";
		$formFieldsText .= "<a href=\"JavaScript:;\" onClick=\"moveChildOneUp('field[".$i."]')\">up</a>&nbsp;";
		$formFieldsText .= "<a href=\"JavaScript:;\" onClick=\"moveChildOneDown('field[".$i."]')\">down</a>&nbsp;|&nbsp;";
		$formFieldsText .= "<a href=\"JavaScript:;\" onClick=\"removeItem('field[".$i."]')\">remove</a>";
		$formFieldsText .= "</span>";
		$formFieldsText .= "</div>";
	}
	$isSendSet = isset($values['mail']['send']) && $values['mail']['send'] == "1";
	$formMailCheckedText = $isSendSet ? " checked=\"checked\"" : "";
	$formMailVisibilityText = $isSendSet ? "" : " style=\"visibility:hidden;display:none;\"";
	$content['body'] .= "
		<form method=\"post\" action=\"\" name=\"updateForm\">
			<div>
				<span style=\"float: left; width: 100px;\">Id:&nbsp;</span>
				<span>".getFormField("hidden","id",$item).$item."</span>
			</div>
			<div>
				<span style=\"float: left; width: 100px;\">Title:&nbsp;</span>
				<span>".getFormField("text","data[title]",$values['title'])."</span>
			</div>
			
			<div><hr></div>
			
			<div>
				<span>Fields:&nbsp;</span>
				<span>
					<div>
						<span>Add a new field: </span>
						<span>
							<input type=\"text\" id=\"addFieldValue\" name=\"addFieldValue\" value=\"\" style=\"width:100px\">
							<input type=\"button\" name=\"addField\" value=\"Add\" style=\"width:50px\" onclick=\"addFormField('addFieldValue');\">
						</span>
					</div>
				</span>
			</div>
			<div id=\"fieldtitles\">
				<span style=\"float: left; width: 100px;\">&nbsp;&nbsp;&nbsp;<b>Id</b></span>
				<span style=\"float: left; width: 150px;\"><b>Display name</b></span>
				<span style=\"float: left; width: 150px;\"><b>Field type</b></span>
				<span style=\"float: left; width: 150px;\"><b>Check statement</b></span>
				<span><b>Message on error</b></span>
			</div>
			<div id=\"fields\">".$formFieldsText."</div>
			<div id=\"submitButtonName\">
				<span style=\"float: left; width: 100px;\"><b>Submit:&nbsp;</b></span>
				<span>".getFormField("text","data[button][submit][name]",$values['button']['submit']['name'])."</span>
			</div>
			<div><hr></div>
			<div>
				<span>Additional JavaScript code on form submit:&nbsp;</span><br>
				<span><textarea id=\"onSubmitJS\" name=\"data[onSubmitJS]\">".$values['onSubmitJS']."</textarea>
			</div>
			<div><hr></div>
			<div>
				<span>Mail after submit:&nbsp;</span>
				<span><input id=\"isMail\" class=\"check\" type=\"checkbox\" name=\"data[mail][send]\" value=\"1\" onChange=\"formActionMail()\"".$formMailCheckedText."></span>
			</div>
			<div id=\"isMailFields\"".$formMailVisibilityText.">
				<div>
					<span style=\"float: left; width: 150px;\"> - From:&nbsp;</span>
					<span>".getFormField("text","data[mail][from]",$values['mail']['from'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - ReplyTo:&nbsp;</span>
					<span>".getFormField("text","data[mail][reply]",$values['mail']['reply'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - To:&nbsp;</span>
					<span>".getFormField("text","data[mail][to]",$values['mail']['to'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Cc:&nbsp;</span>
					<span>".getFormField("text","data[mail][cc]",$values['mail']['cc'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Bcc:&nbsp;</span>
					<span>".getFormField("text","data[mail][bcc]",$values['mail']['bcc'])."</span>
				</div>
				
				<div>
					<span style=\"float: left; width: 150px;\"> - Subject:&nbsp;</span>
					<span>".getFormField("text","data[mail][subject]",$values['mail']['subject'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Body:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][body]",$values['mail']['body'])."</span>
				</div>
				
				<div>
					<span style=\"float: left; width: 150px;\"> - Success message:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][success]",$values['mail']['success'])."</span>
				</div>
				<div>
					<span style=\"float: left; width: 150px;\"> - Error message:&nbsp;</span>
					<span>".getFormField("textarea","data[mail][error]",$values['mail']['error'])."</span>
				</div>
			</div>
			
			<div>&nbsp;</div>
			
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Update form\" onclick=\"submitForm('updateForm')\">
				</span>
			</div>
		</form>
	";
}

// Remove form
if (isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "remove") {
	$item = $_GET['item'];
	if (!isFormAvailable($item)) { pageForward("?page=".$page); }
	if (isset($_POST['id'])) {
		$formId = $_POST['id'];
		if ($formId == "") { pageForward("?page=".$page."&action=removed&error=empty"); }
		if (!hasStdLettersOnly($formId)) { pageForward("?page=".$page."&action=removed&error=syntax"); }
		if ($formId != $item) { pageForward("?page=".$page."&action=removed&error=wrongid"); }
		removeJson("forms/".$formId); pageForward("?page=".$page."&action=removed");
	}
	$content['body'] .= "
		<form method=\"post\" action=\"\" name=\"removeForm\">
			".getFormField("hidden","id",$item)."
			<div>Do you really want to delete the form '".$item."'?</div>
			<div>&nbsp;</div>
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"No\" onclick=\"loadUrl('?page=".$page."&item=".$item."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Yes\" onclick=\"submitForm('removeForm')\">
				</span>
			</div>
		</form>
	";
}
?>
