<?

$content = array();
$content['title'] = "Tables";
$content['body'] = "";

$fixTables = "user,group,user_group,function";
$fixTablesArray = split(",",$fixTables); 

include_once('../inc/db.php');

function isTableNotFix($tableName) {
	global $fixTablesArray;
	foreach(array_keys($fixTablesArray) as $f) {
		if ($tableName == $fixTablesArray[$f]) { return TRUE; }
		if ($tableName == constant("DB_TABLE_PREFIX").$fixTablesArray[$f]) { return TRUE; }
	}
	return FALSE;
}
function isTableAvailable($tableName) {
	$Table = mysql_query("show tables like '" . constant("DB_TABLE_PREFIX").$tableName . "'");
	return mysql_fetch_row($Table);
}
function getTables() {
	global $db, $db_data, $fixTablesArray;
	$tables = mysql_list_tables($db_data['database']);
	$x=1; $prefix = constant("DB_TABLE_PREFIX");
	while($line = mysql_fetch_row($tables)) {
		$tableName = $line[0];
		if (!isTableNotFix($tableName) && substr($tableName,0,strlen($prefix)) == $prefix) {
			$x++; $array[$x]['name'] = substr($tableName,strlen($prefix));
		}
	}
	return $array;
}
function getTableFieldNames($table) { return runsql("SHOW COLUMNS FROM ".constant("DB_TABLE_PREFIX").$table); }
function getTableFieldCount($table) { $result = getTableFieldNames($table); return count(array_keys($result)); }
function getTableItemCount($table) { $result = runsql("SELECT COUNT(*) FROM ".constant("DB_TABLE_PREFIX").$table); return $result[1]['COUNT(*)']; }

$tables = getTables();

function isTableInUse($table) {
	global $tables;
	foreach(array_keys($tables) as $t) { 
		$tbl = $tables[$t];
		$result = runsql("SHOW COLUMNS FROM ".constant("DB_TABLE_PREFIX").$tbl);
		foreach(array_keys($result) as $r) { if (isValid($result[$r],"/(fkid_".$table.".*)/")) { return TRUE; } }
	}
	return FALSE;
}
function isTableFieldInUse($table,$field) {
	global $tables;
	foreach(array_keys($tables) as $t) { 
		$tbl = $tables[$t];
		$result = runsql("SHOW COLUMNS FROM ".constant("DB_TABLE_PREFIX").$tbl);
		foreach(array_keys($result) as $r) { if (isValid($result[$r],"/(fkid_".$table."_".$field.".*)/")) { return TRUE; } }
	}
	return FALSE;
}

if (isset($_GET['table'])) {
	$table = $_GET['table'];
	if (!isTableAvailable($table)) { pageForward("?page=".$page); }
	$contentTitle = "Table '".$table."'";
}

$content['body'] .= "
	<table><tr><td style=\"vertical-align:top;width:150px;\">
		Table navigation<hr>
		<a href=\"?page=".$page."&action=add\">Add a table</a><br><br>
";
foreach(array_keys($tables) as $t) {
	$isActive = isset($table) && $table == $tables[$t]['name']; $tableText = $tables[$t]['name'];
	$tableText = $isActive ? "<b>".$tableText."</b>" : $tableText;
	$content['body'] .= "<div><a href=\"?page=".$page."&table=".$tables[$t]['name']."\">".$tableText."</a></div>";
}
$content['body'] .= "</td><td style=\"width:20px;\">&nbsp;</td>";

// Tables overview
if (!isset($_GET['table']) && !isset($_GET['action'])) {
	$contentTitle = "Tables";
	$contentBody = "
		Use this part for managing your database tables. 
		You can query these tables on '<a href=\"?page=design\">Design</a>', 
		'<a href=\"?page=pages\">Pages</a>' and '<a href=\"?page=forms\">Forms</a>'.<br>
		Select query syntax: [table]('<em>TABLE_NAME</em>' where '<em>SQL_WHERE_STATEMENT</em>' as '<em>RETURN_ARRAY</em>')[/table]<br>
		You'll get back an array that you can use by a [foreach][/foreach] or directly. 
		Array call like {{table:<em>RETURN_ARRAY</em>:<em>ANY_ITEM_NO</em>:<em>ANY_FIELD_NAME</em>}}.
		<br><br>
		<div class=\"example\">
			<div class=\"example title\">For example: </div>
			<div class=\"example text\">
				If you want to get all items from the table 'testtbl' that have the id less than 4 
				and want to print out the fields 'name' value just from the first item, it looks like this: 
				<em>
					[table]('testtbl' where '<em>id &lt; 4</em>' as 'items')[/table]
					{{table:items:1:name}}
				</em> 
				And if you want to print the value of name from all that requested db items: 
				<em>[foreach] ('items' as 'i') { {{table:items:{{i}}:name}} &lt;br&gt; } [/foreach]</em>
			</div>
		</div>
		";
	/*
	$contentBody .= "<br><br>
		<a href=\"?page=".$page."&action=add\">Add a new table</a><br><br>
		<table>
		<tr><td colspan=\"5\"><hr></td></tr>
		<tr>
			<th>Name&nbsp;&nbsp;&nbsp;</th>
			<th>Fields&nbsp;&nbsp;&nbsp;</th>
			<th>Items&nbsp;&nbsp;&nbsp;</th>
			<th>Actions</th>
		</tr>
		<tr><td colspan=\"5\"><hr></td></tr>
	";
	foreach(array_keys($tables) as $t) { 
		$table = $tables[$t];
		$fieldCount = getTableFieldCount($table['name']);
		$columnCount = getTableItemCount($table['name']);
		// print_r($tableName);
		$changeText = "<a href=\"?page=".$page."&table=".$table['name']."&action=change\">change</a>";
		$removeText = "<a href=\"?page=".$page."&table=".$table['name']."&action=remove\">remove</a>";
		$contentBody .= "
			<tr>
				<td><a href=\"?page=".$page."&table=".$table['name']."\">".$table['name']."</a>&nbsp;&nbsp;&nbsp;</td>
				<td>".$fieldCount."&nbsp;&nbsp;&nbsp;</td>
				<td>".$columnCount."&nbsp;&nbsp;&nbsp;</td>
				<td>".$changeText."&nbsp;|&nbsp;".$removeText."</td>
			</tr>";
	}
	$contentBody .= "<tr><td colspan=\"5\"><hr></td></tr></table>";
	*/
}

// add,change,remove table items and fields messages
if (!isset($_GET['table']) && !isset($_GET['view']) && isset($_GET['action'])) {
	$error = isset($_GET['error']) ? $_GET['error'] : "";
	if ($_GET['action'] == "added" && $error == "") { $message = "The table was created successfully."; }
	if ($_GET['action'] == "updated" && $error == "") { $message = "The table name was changed successfully."; }
	if ($_GET['action'] == "removed" && $error == "") { $message = "The table was removed successfully."; }
	if ($error == "exist") { $message = "Table already exists."; }
	if ($error == "syntax") { $message = "One or more values are not well formed."; }
	if (isset($message)) {
		$link = $error == "" ? "<a href=\"?page=".$page."\">Go back</a>" : "<a href=\"javascript:;\" onClick=\"history:back(-1)\">Try again</a>";
		$contentTitle = $message; $contentBody = $link;
	}
}

// Add table
if (!isset($_GET['table']) && !isset($_GET['field']) && !isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "add") {
	if (isset($_POST['id'])) {
		$fwurl = "?page=".$page."&action=added";
		if (!hasStdLettersOnly($_POST['name'])) { pageForward($fwurl."&error=syntax"); }
		foreach(array_keys($tables) as $t) { if ($tables[$t]['name'] == $_POST['name']) { pageForward($fwurl."&error=exist"); } }
		$databaseName = $db_data['database']; $tableName = constant("DB_TABLE_PREFIX").$_POST['name'];
		runsql("CREATE TABLE `".$databaseName."`.`".$tableName."` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY) ENGINE = InnoDB;");
		pageForward($fwurl."");
	}
	$contentTitle = "Add a table";
	$contentBody = "
	<form method=\"post\" action=\"\" name=\"addForm\"><table>
		".getFormField("hidden","id","0")."<table>
		<tr><td>Name&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","name","")."</td></tr>
		<tr><td colspan=\"2\">&nbsp;</td></tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Add table\" onclick=\"submitForm('addForm')\">
				</span>
			</td>
		</tr>
	</table></form>
	";
}

if (isset($_GET['table'])) {
	$table = $_GET['table']; if (!(hasStdLettersOnly($table) && isTableAvailable($table))) { pageForward("?page=".$page); }
	$fieldCount = getTableFieldCount($table); $columnCount = getTableItemCount($table);
	$contentBody = "
		The table '".$table."' has ".$fieldCount." fields and ".$columnCount." items in it.<br><br>
		Select one of the buttons above to manage that tables structure/items, change the table name and remove that table.
	";
}

// Change table
if (isset($_GET['table']) && !isset($_GET['field']) && !isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "change") {
	if (isset($_POST['id'])) {
		$fwurl = "?page=".$page."&action=updated";
		if (!hasStdLettersOnly($_POST['name'])) { pageForward($fwurl."&error=syntax"); }
		foreach(array_keys($tables) as $t) { if ($tables[$t]['name'] == $_POST['name']) { pageForward($fwurl."&error=exist"); } }
		$databaseName = $db_data['database']; $tableName = constant("DB_TABLE_PREFIX").$_POST['name'];
		runsql("RENAME TABLE `".constant("DB_TABLE_PREFIX").$_POST['id']."` TO `".$tableName."`");
		pageForward($fwurl."");
	}
	$contentTitle = "Change table name";
	$contentBody = "
	<form method=\"post\" action=\"\" name=\"addForm\"><table>
		".getFormField("hidden","id",$_GET['table'])."<table>
		<tr><td>Name&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","name",$_GET['table'])."</td></tr>
		<tr><td colspan=\"2\">&nbsp;</td></tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."&table=".$table."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Change table name\" onclick=\"submitForm('addForm')\">
				</span>
			</td>
		</tr>
	</table></form>
	";
}

// Remove table
if (isset($_GET['table']) && !isset($_GET['field']) && !isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "remove") {
	if (isset($_POST['id'])) {
		runsql("DROP TABLE `".constant("DB_TABLE_PREFIX").$_POST['id']."`");
		pageForward("?page=".$page."&action=removed");
	}
	$contentTitle .= " - Remove field";
	$contentBody = "
		<form method=\"post\" action=\"\" name=\"removeForm\">
			".getFormField("hidden","id",$table)."
			<div>Do you really want to delete the table '".$table."'?</div>
			<div>&nbsp;</div>
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"No\" onclick=\"loadUrl('?page=".$page."&table=".$table."')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Yes\" onclick=\"submitForm('removeForm')\">
				</span>
			</div>
		</form>
	";
}

// Display table structure
if (isset($_GET['table']) && isset($_GET['view']) && $_GET['view'] == "structure" && !isset($_GET['action'])) {
	$contentTitle .= " - Structure view";
	$contentBody = "<a href=\"?page=".$page."&table=".$table."&field=0&action=add\">Add a field</a><br><br>";
	$contentBody .= "<table><tr>";
	$contentBody .= "
		<th>Type&nbsp;&nbsp;&nbsp;</th>
		<th>Name&nbsp;&nbsp;&nbsp;</th>
		<td>&nbsp;</td>
		</tr>
	";
	
	$fields = getTableFieldNames($table);
	// print_r($fields);
	foreach(array_keys($fields) as $f) {
		$contentBody .= "<tr>";
		$contentBody .= "<td>".$fields[$f]['Type']."&nbsp;&nbsp;&nbsp;</td>";
		$contentBody .= "<td>".$fields[$f]['Field']."&nbsp;&nbsp;&nbsp;</td>";
		// $contentBody .= "<td>".$fields[$f]['Null']."&nbsp;&nbsp;&nbsp;</td>";
		// $contentBody .= "<td>".$fields[$f]['Key']."&nbsp;&nbsp;&nbsp;</td>";
		// $contentBody .= "<td>".$fields[$f]['Extra']."&nbsp;&nbsp;&nbsp;</td>";
		if ($fields[$f]['Field'] != "id") {
			$contentBody .= "
				<td>
					<a href=\"?page=".$page."&table=".$table."&field=".$fields[$f]['Field']."&action=change\">change</a> 
					<a href=\"?page=".$page."&table=".$table."&field=".$fields[$f]['Field']."&action=remove\">Remove</a>
				</td>
			";
		} else { $contentBody .= "<td>&nbsp;</td>"; }
		$contentBody .= "</tr>\n";
	}
	$contentBody .= "</table>";
}

// Display table items
if (isset($_GET['table']) && isset($_GET['view']) && $_GET['view'] == "items" && !isset($_GET['action'])) {
	$contentTitle .= " - Items view";
	$contentBody = "<a href=\"?page=".$page."&table=".$table."&item=0&action=add\">Add an item</a><br><br>";
	$contentBody .= "<table><tr>";
	$fields = getTableFieldNames($table);
	foreach(array_keys($fields) as $f) { $contentBody .= "<th>".$fields[$f]['Field']."&nbsp;&nbsp;&nbsp;</th>"; }
	$contentBody .= "<td>&nbsp;</td></tr>\n";
	$columns = sql_select(constant("DB_TABLE_PREFIX").$table,"");
	// print_r($columns); die();
	foreach(array_keys($columns) as $c) {
		$contentBody .= "<tr>";
		foreach(array_keys($columns[$c]) as $f) { $contentBody .= "<td>".$columns[$c][$f]."&nbsp;&nbsp;&nbsp;</td>"; }
		$contentBody .= "
			<td>
				<a href=\"?page=".$page."&table=".$table."&item=".$columns[$c]['id']."&action=change\">change</a> 
				<a href=\"?page=".$page."&table=".$table."&item=".$columns[$c]['id']."&action=remove\">Remove</a>
			</td>
		";
		$contentBody .= "</tr>\n";
	}
	$contentBody .= "</table>";
}

// add,change,remove table items and fields messages
if (isset($_GET['table']) && isset($_GET['view']) && isset($_GET['action'])) {
	$error = isset($_GET['error']) ? $_GET['error'] : "";
	if ($_GET['action'] == "added" && $error == "") { $message = "The item was created successfully."; }
	if ($_GET['action'] == "updated" && $error == "") { $message = "The item was changed successfully."; }
	if ($_GET['action'] == "removed" && $error == "") { $message = "The item was removed successfully."; }
	
	if ($error == "exist") { $message = "Item already exists."; }
	if ($error == "syntax") { $message = "One or more values are not well formed."; }
	if (isset($message)) {
		$link = $error == "" ? "<a href=\"?page=".$page."&table=".$table."&view=".$_GET['view']."\">Go back</a>" : "<a href=\"javascript:;\" onClick=\"history:back(-1)\">Try again</a>";
		$contentTitle = $message; $contentBody = $link;
	}
}

// Add table field
if (isset($_GET['table']) && isset($_GET['field']) && isset($_GET['action']) && $_GET['action'] == "add") {
	if (isset($_POST['id'])) {
		$fields = getTableFieldNames($table);
		$fwurl = "?page=".$page."&table=".$table."&table=".$table."&view=structure&action=added";
		if (!hasStdLettersOnly($_POST['field'])) { pageForward($fwurl."&error=syntax"); }
		foreach(array_keys($fields) as $f) { if ($fields[$f]['Field'] == $_POST['field']) { pageForward($fwurl."&error=exist"); } }
		$length = $_POST['length']; $length = $length < 1 || $length > 1000 ? 300 : $length;
		runsql("ALTER TABLE `".constant("DB_TABLE_PREFIX").$table."` ADD `".htmlHexChars($_POST['field'])."` VARCHAR( ".$length." ) NOT NULL");
		pageForward($fwurl."");
	}
	$contentTitle .= " - Add a field";
	$contentBody = "
	<form method=\"post\" action=\"\" name=\"addForm\"><table>
		".getFormField("hidden","id","0")."<table>
		<tr><td>Name&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","field","")."</td></tr>
		<tr><td>Max Length&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","length","300")."</td></tr>
		<tr><td colspan=\"2\">&nbsp;</td></tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=structure')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Add table item\" onclick=\"submitForm('addForm')\">
				</span>
			</td>
		</tr>
	</table></form>
	";
}

// Change table field
if (isset($_GET['table']) && isset($_GET['field']) && isset($_GET['action']) && $_GET['action'] == "change") {
	if (isset($_POST['id'])) {
		$fields = getTableFieldNames($table);
		$fwurl = "?page=".$page."&table=".$table."&table=".$table."&view=structure&action=updated";
		if (!hasStdLettersOnly($_POST['field'])) { pageForward($fwurl."&error=syntax"); }
		if ($_POST['id'] != $_POST['field']) {
			foreach(array_keys($fields) as $f) {
				if ($fields[$f]['Field'] == $_POST['field']) {
					pageForward($fwurl."&error=exist");
				}
			}
		}
		$length = $_POST['length']; $length = $length < 1 || $length > 1000 ? 300 : $length;
		runsql("ALTER TABLE `".constant("DB_TABLE_PREFIX").$table."` CHANGE `".$_POST['id']."` `".htmlHexChars($_POST['field'])."` VARCHAR( ".$length." ) NOT NULL");
		pageForward($fwurl."");
	}
	$fields = getTableFieldNames($table);
	foreach(array_keys($fields) as $f) { if ($fields[$f]['Field'] == $_GET['field']) { $type = $fields[$f]['Type']; } }
	if (isset($type)) { $type = str_replace("varchar(","",$type); $type = str_replace(")","",$type); } else { $type = "300"; }
	$contentTitle .= " - Change field";
	$contentBody = "
	<form method=\"post\" action=\"\" name=\"addForm\"><table>
		".getFormField("hidden","id",$_GET['field'])."<table>
		<tr><td>Name&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","field",$_GET['field'])."</td></tr>
		<tr><td>Max Length&nbsp;&nbsp;&nbsp;</td><td>".getFormField("text","length",$type)."</td></tr>
		<tr><td colspan=\"2\">&nbsp;</td></tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=structure')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Update table item\" onclick=\"submitForm('addForm')\">
				</span>
			</td>
		</tr>
	</table></form>
	";
}

// Remove table item
if (isset($_GET['table']) && isset($_GET['field']) && isset($_GET['action']) && $_GET['action'] == "remove") {
	$item = $_GET['field'];
	if (isset($_POST['id'])) {
		$pageId = $_POST['id'];
		runsql("ALTER TABLE `".constant("DB_TABLE_PREFIX").$table."` DROP `".$_POST['id']."`");
		pageForward("?page=".$page."&table=".$table."&table=".$table."&view=structure&action=removed");
	}
	$contentTitle .= " - Remove field";
	$contentBody = "
		<form method=\"post\" action=\"\" name=\"removeForm\">
			".getFormField("hidden","id",$item)."
			<div>Do you really want to delete the table field '".$item."'?</div>
			<div>&nbsp;</div>
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"No\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=structure')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Yes\" onclick=\"submitForm('removeForm')\">
				</span>
			</div>
		</form>
	";
}

// Add table item
if (isset($_GET['table']) && isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "add") {
	if (isset($_POST['id'])) {
		$fields = $_POST['fields'];
		sql_insert(constant("DB_TABLE_PREFIX").$table,$fields);
		pageForward("?page=".$page."&table=".$table."&table=".$table."&view=items&action=added");
	}
	$contentTitle .= " - Add an item";
	$contentBody = "<form method=\"post\" action=\"\" name=\"addForm\"><table>";
	$contentBody .= getFormField("hidden","id","0")."<table>";
	$fields = getTableFieldNames($table);
	foreach(array_keys($fields) as $f) {
		if ($fields[$f]['Field'] != "id") {
			$contentBody .= "
				<tr>
					<td>".$fields[$f]['Field']."&nbsp;&nbsp;&nbsp;</td>
					<td>".getFormField("text","fields[".$fields[$f]['Field']."]","")."</td>
				</tr>
			";
		}
	}
	$contentBody .= "
			<tr><td colspan=\"2\">&nbsp;</td></tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<span>
						<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=items')\">
						&nbsp;&nbsp;
						<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Add table item\" onclick=\"submitForm('addForm')\">
					</span>
				</td>
			</tr>
		</table></form>
	";
}

// Change table item
if (isset($_GET['table']) && isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "change") {
	if (isset($_POST['id'])) {
		$fields = $_POST['fields'];
		sql_update(constant("DB_TABLE_PREFIX").$table,$fields,"id = ".$_GET['item']);
		pageForward("?page=".$page."&table=".$table."&table=".$table."&view=items&action=updated");
	}
	$contentTitle .= " - Change item";
	$contentBody = "<form method=\"post\" action=\"\" name=\"addForm\"><table>";
	$contentBody .= getFormField("hidden","id",$_GET['item'])."<table>";
	$fields = getTableFieldNames($table);
	foreach(array_keys($fields) as $f) {
		if ($fields[$f]['Field'] != "id") {
			$values = sql_select(constant("DB_TABLE_PREFIX").$table,"id = ".$_GET['item']);
			$contentBody .= "
				<tr>
					<td>".$fields[$f]['Field']."&nbsp;&nbsp;&nbsp;</td>
					<td>".getFormField("text","fields[".$fields[$f]['Field']."]",$values[1][$fields[$f]['Field']])."</td>
				</tr>
			";
		}
	}
	$contentBody .= "
			<tr><td colspan=\"2\">&nbsp;</td></tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<span>
						<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"Discard\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=items')\">
						&nbsp;&nbsp;
						<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Update table item\" onclick=\"submitForm('addForm')\">
					</span>
				</td>
			</tr>
		</table></form>
	";
}

// Remove table item
if (isset($_GET['table']) && isset($_GET['item']) && isset($_GET['action']) && $_GET['action'] == "remove") {
	$item = $_GET['item'];
	if (isset($_POST['id'])) {
		$pageId = $_POST['id'];
		sql_remove(constant("DB_TABLE_PREFIX").$table,"id = ".$_GET['item']);
		pageForward("?page=".$page."&table=".$table."&table=".$table."&view=items&action=removed");
	}
	$contentTitle .= " - Remove item";
	$contentBody = "
		<form method=\"post\" action=\"\" name=\"removeForm\">
			".getFormField("hidden","id",$item)."
			<div>Do you really want to delete the table item with the id '".$item."'?</div>
			<div>&nbsp;</div>
			<div>
				<span>
					<input class=\"submit\" type=\"button\" name=\"discardFormButton\" value=\"No\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=items')\">
					&nbsp;&nbsp;
					<input class=\"submit\" type=\"button\" name=\"submitFormButton\" value=\"Yes\" onclick=\"submitForm('removeForm')\">
				</span>
			</div>
		</form>
	";
}

if (isset($_GET['table'])) {
	$contentTitle = "<div>
		<span>
			<input class=\"submit\" type=\"button\" name=\"TableStructure\" value=\"Go to table structure\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=structure')\">
			&nbsp;&nbsp;
			<input class=\"submit\" type=\"button\" name=\"TableItems\" value=\"Go to table items\" onclick=\"loadUrl('?page=".$page."&table=".$table."&view=items')\">
			&nbsp;&nbsp;
			<input class=\"submit\" type=\"button\" name=\"changeTable\" value=\"Change table name\" onclick=\"loadUrl('?page=".$page."&table=".$table."&action=change')\">
			&nbsp;&nbsp;
			<input class=\"submit\" type=\"button\" name=\"removeTable\" value=\"Remove this table\" onclick=\"loadUrl('?page=".$page."&table=".$table."&action=remove')\">
		</span>
	</div><hr>" . $contentTitle;
	if (!isset($contentBody)) { $contentBody = ""; }
}

if (isset($contentTitle) && isset($contentBody)) { $content['body'] .= "<td style=\"vertical-align:top;\"><h2>".$contentTitle."</h2><hr>".$contentBody."</td></tr></table>"; }

mysql_close($db);

?>
