<?

// [ START ] --- CONFIG FUNCTIONS ---
function cmsConfigError($string) { $output = "<h1>kyfoo config error</h1>\n<h2>".$string."</h2>"; die($output); }
// [  END  ] --- CONFIG FUNCTIONS ---


// [ START ] --- REDIRECT FUNCTIONS ---
function pageForward($location) { header('Location: '.$location); }
function denied() { pageForward("?page=denied"); die(); }
// [  END  ] --- REDIRECT FUNCTIONS ---

// [ START ] --- AUTHENTICATE FUNCTIONS ---
function getNewHash($string) { return sha1(md5($string),FALSE); }
function getCryptedPassword($pwd) { return sha1(strrev(md5($pwd)),FALSE); }
function getNewUserHash($userName) { return getNewHash($userName."-".time()); }
function setUserCookie($value) { setcookie("kyfoo_user", $value); }
function getUserCookie() { return isset($_COOKIE["kyfoo_user"]) ? $_COOKIE["kyfoo_user"] : FALSE; }
function destroyUserCookie() { setcookie("kyfoo_user", "", time()); }
function getUserById($id) { $result = sql_select(constant("DB_TABLE_PREFIX")."user","id = ".$id); return $result[1]; }
function getUserByName($name) { $result = sql_select(constant("DB_TABLE_PREFIX")."user","username = '".$name . "'"); return $result[1]; }
function getUserByHash($hash) { $result = sql_select(constant("DB_TABLE_PREFIX")."user","hash = '".$hash . "'"); return $result[1]; }
function getUser() { return isAuthenticated() ? $_SESSION['user'] : FALSE; }
function isAuthenticated() { 
	if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE && isset($_SESSION['user'])) {
		$user = $_SESSION['user'];
		if (isset($user['id']) && $user['id'] > 0) {
			return isset($_SESSION['site'][htmlHexChars(constant('PROJECT_ROOT'))]);
		}
	}
	return FALSE;
}
function authenticate($userName,$password) {
	unset($_SESSION['auth']); unset($_SESSION['isAdmin']);  unset($_SESSION['isModerator']);
	unset($_SESSION['site'][htmlHexChars(constant('PROJECT_ROOT'))]);
	if (!hasStdLettersOnly($userName)) { return FALSE; }
	$user = getUserByName($userName);
	if (is_array($user) && $user != array()) {
		$_SESSION['auth'] = (getCryptedPassword($password) == $user['password']);
		if ($_SESSION['auth'] === TRUE) {
			$user['hash'] = getNewUserHash($user['username']);
			$values = array("hash"=>$user['hash'],"fix_modifiedby"=>$user['id']);
			sql_update(constant("DB_TABLE_PREFIX")."user",$values,"id = ".$user['id']);
			setUserCookie($user['hash']);
			$_SESSION['isAdmin'] = ($user['id'] == "1") || ($user['level'] == 1);
			$_SESSION['isModerator'] = ($user['id'] == "1") || ($user['level'] == 1) || ($user['level'] == 2);
			$_SESSION['user'] = $user;
			$_SESSION['site'][htmlHexChars(constant('PROJECT_ROOT'))] = TRUE; return TRUE;
		}
		unset($user); unset($_SESSION['auth']); unset($_SESSION['isAdmin']);  unset($_SESSION['isModerator']); 
		return FALSE;
	}
	return FALSE;
}
function logout() { session_destroy(); destroyUserCookie(); }
// [  END ] --- AUTHENTICATE FUNCTIONS ---

// [ START ] --- DATABASE FUNCTIONS ---
function runsql($query) {
	$x=0; $array = array(); $result = mysql_query($query) or die('Query: '.$query.'<br>Failed: '.mysql_error());
	if ($result == 1) { return TRUE; } if ($result == 0) { return FALSE; }
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) { $x++; $array[$x] = $line; }
	return $array;
}
function sql_select($tbl,$where) {
	$where = !($where == FALSE || $where == "") ? " WHERE " . $where : "";
	$query = "SELECT * FROM " . $tbl . $where;
	return runsql($query);
}
function sql_insert($tbl,$attr) {
	$col = ""; $val = "";
	foreach (array_keys($attr) as $i) { $col .= $i . ","; $val .= "'" . htmlHexChars($attr[$i]) . "',"; }
	$col = "(" . substr($col,0,-1) . ")"; $val  = "(" . substr($val,0,-1) . ")";
	$query = "INSERT INTO " . $tbl . " " . $col . " VALUES " . $val;
	return runsql($query);
}
function sql_update($tbl,$attr,$where) {
	$col = "";
	foreach (array_keys($attr) as $i) { $col .= $i . "='" . htmlHexChars($attr[$i]) . "', "; }
	$col = substr($col,0,-2);
	$query = "UPDATE " . $tbl . " SET " . $col . " WHERE " . $where;
	return runsql($query);
}
function sql_remove($tbl,$where) {
	$query = "DELETE FROM " . $tbl . " WHERE " . $where;
	return runsql($query);
}
function getFkValues($items) {
	/*
	 * $regex = "/fkid_(.*?)_(.*?)_(.*?)/is";
	foreach(array_keys($items) as $x) {
		foreach(array_keys($items[$x]) as $i) {
			$value = $items[$x][$i];
			preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER);
			if (is_array($rvalue[0]) && isset($rvalue[0][1]) && isset($rvalue[0][2]) && isset($rvalue[0][3])) {
				$fkTbl = $rvalue[0][1]; $fkFn = $rvalue[0][2]; $fieldName = $rvalue[0][3];
				$fkResult = sql_select($fkTbl,"id = ".$items[$x][$i]);
				unset($items[$x][$i]); $items[$fieldName] = $fkResult[$fkFn];
			}
		}
	}
	*/
	return $items;
}
// [  END  ] --- DATABASE FUNCTIONS ---

// TODO File-Upload
// ...


// [ START ] --- FILESYSTEM FUNCTIONS ---
function setFilePerm($path) { $perm = 0640; if (fileperms($path) != $perm) { chmod($path, $perm); } }
function writeFile($path,$body) {
	$path = constant('SERVER_PROJECT_ROOT').$path;
	$e = file_exists($path) ? "w" : "a+";
	$fh = fopen($path, $e); fwrite($fh, $body); fclose($fh);
}
function removeFile($path) { $path = constant('SERVER_PROJECT_ROOT').$path; unlink($path); }
// [  END  ] --- FILESYSTEM FUNCTIONS ---


// [ START ] --- STRING ENCODE and DECODE FUNCTIONS ---
function removeStrange($string) { return; /* TODO ... */ }
function htmlHexChars($string) {
	
	$string = htmlentities($string, ENT_SUBSTITUTE, "UTF-8");
	$string = str_replace(array("&lt;", "&gt;", "&amp;"), array("<", ">", "&"), $string);
	return $string;
	/*
    $returnvalue = "";
    for ($i=0; $i<strlen($string); $i++) {
		$part=hexdec(rawurlencode(substr($string, $i, 1)));
        if ($part < 128 || $part > 1114111) { $returnvalue .= substr($string, $i, 1); } else {
			$returnvalue .= "&#".$part.";";
			// $returnvalue .= htmlentities(substr($string, $i, 1), ENT_SUBSTITUTE, "UTF-8");
		}
    }
    return $returnvalue;
    */
    
}
// [  END  ] --- STRING ENCODE and DECODE FUNCTIONS ---


// [ START ] --- REGEX FUNCTIONS ---
function getRegExResult($string,$regex) { preg_match_all($regex, $string, $result, PREG_SET_ORDER); return $result; }
function isValid($string,$regex) { $result = getRegExResult($string,$regex); return isset($result[0]) && isset($result[0][1]) && $result[0][1] == $string; }
function isNumber($string) { return isValid($string,"/([0-9]*)/"); }
function hasStdLettersOnly($string) { return isValid($string,"/([a-zA-Z0-9-_]*)/"); }
function isAscii($string) { return isValid($string,"/([a-zA-Z0-9`~!@#$%^&*()-=_+[]{};'\:\"|,./<>?]*)/"); }
function isEmpty($string) { return strlen($string) < 0; }
// [  END ] --- REGEX FUNCTIONS ---


// [ START ] --- JSON MAIN FUNCTIONS ---
function getJsonPath($name) { return constant('SERVER_PROJECT_ROOT').".json/".$name.".json"; }
function jsonExists($name) { return file_exists(getJsonPath($name)); }
function getJson($name) { return json_decode(file_get_contents(getJsonPath($name)),TRUE); }
function writeJson($name,$array) { $fh = fopen(getJsonPath($name), 'w'); fwrite($fh, json_encode($array)); fclose($fh); setFilePerm(getJsonPath($name)); }
function removeJson($name) { if (jsonExists($name) === TRUE) { unlink(getJsonPath($name)); } }
// [  END  ] --- JSON MAIN FUNCTIONS ---


// [ START ] --- PAGE FUNCTIONS ---
function getErrorPage($error) {
	$info = getJson("info"); $json = getJson("errorData"); $page = $json['page'][$error];
	$page['description'] = $page['title']; $page['meta_description'] = ""; $page['meta_keywords'] = "";
	$contactText = isset($json['contact']) && $json['contact'] != "" ? $json['contact'] . "<br><br>\n" : "";
	$technicalContact = "<a href=\"".$info['cms']['url']."\" target=\"_blank\">".$info['cms']['name']."</a>";
	$page['body'] = "<b>".$page['body']."</b>\n\n<br><br>\n".$contactText."";
	return $page;
}
function isPageAvailable($name) { return jsonExists("pages/".$name); }
function isPageValid($page) { return isset($page['title']) && isset($page['body']); }
function isPageAllowed($page) { return TRUE; /* TODO after permission management integration */ }
function getPage($name) {
	if (!hasStdLettersOnly($name)) { return getErrorPage("403"); }
	if (!isPageAvailable($name)) { return getErrorPage("404"); }
	$page = getJson("pages/".$name);
	if (!isPageValid($page)) { return getErrorPage("500"); }
	$page['id'] = $name; return $page;
}
// [  END  ] --- PAGE FUNCTIONS ---


// [ START ] --- NAVIGATION FUNCTIONS ---
function getNavStructure($array,$page) {
	if (!is_array($array)) { return array(); }
	foreach($array as $k => $v) {
		if ($k == $page) { $array[$k]['active'] = "1"; return $array; }
		if (isset($array[$k]['sub'])) {
			$isInSub = false;
			foreach($array[$k]['sub'] as $subk => $subv) {
				if (array_key_exists($page,$array[$k]['sub'][$subk]['sub'])) {
					$isInSub = true;
				}
			}
			if (array_key_exists($page,$array[$k]['sub']) || $isInSub === true) {
				$array[$k]['active'] = "1";
				$array[$k]['sub'] = getNavStructure($array[$k]['sub'],$page);
				return $array;
			}
		}
	}
	return $array;
}
function getNavigationItems($page="home") {
	if (!jsonExists("navigation")) { cmsConfigError("No navigation available."); }
	$nav = getJson("navigation");
	$nav = getNavStructure($nav,$page);
	return $nav;
}
// [  END ] --- NAVIGATION FUNCTIONS ---


// [ START ] --- TEMPLATE FUNCTIONS ---
function dynValues($value,$data) {
	$array = dynTables($value,$data);
	$array = dynForEach($array['value'],$array['data']);
	$array = dynIf($array['value'],$array['data']);
	$value = $array['value']; $data = $array['data'];
	$regex = "/{{(.*?)}}/is";
	preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER);
	foreach(array_keys($rvalue) as $i) {
		if (is_array($rvalue[$i]) && isset($rvalue[$i][1])) {
			$part = $rvalue[$i][1]; $isForm = FALSE;
			if (isValid($part,"/(form:.*)/")) {
				$isForm = TRUE; $new = getForm(substr($part,strlen("form:")),$data);
				$value = str_replace($rvalue[$i][0],$new,$value);
			}
			if (!$isForm) {
				$split = split(":",$part); $new = $data;
				foreach(array_keys($split) as $s) { $new = is_array($new) && isset($new[$split[$s]]) ? $new[$split[$s]] : ""; }
				if (!is_array($new) && is_string($new)) {
					$regex2 = "/{{(.*?)}}/is";
					preg_match_all($regex2, $new, $r2value, PREG_SET_ORDER);
					if (is_array($r2value) && $r2value != array()) { $new = dynValues($new,$data); }
					$value = str_replace($rvalue[$i][0],$new,$value);
				}
			}
		}
	}
	preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER); if (is_array($rvalue) && $rvalue != array()) { $value = dynValues($value,$data); }
	return $value;
}
function replaceDefaultPlaceholders($string) { return dynValues($string,getDefaultPlaceholders()); }
function dynTables($value,$data) {
	global $needDb;
	// [table]('test' where 'id = 1' as 'testdata')[/table]
	// [table] ( 'test' where 'id = 1' as 'testdata' ) [/table]
	$regex = "/\[table\]\s*\(\s*'(.*?)'\s*where\s*'(.*?)'\s*as\s*'(.*?)'\s*\)\s*\[\/table\]/is";
	preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER);
	$new = "";
	foreach(array_keys($rvalue) as $r) {		
		if (is_array($rvalue[$r]) && isset($rvalue[$r][1]) && isset($rvalue[$r][2])) {
			$table = replaceDefaultPlaceholders($rvalue[$r][1]);
			$where = replaceDefaultPlaceholders($rvalue[$r][2]);
			$rName = replaceDefaultPlaceholders($rvalue[$r][3]);
			if (hasStdLettersOnly($table) /*&& isTableAvailable($table)*/) {
				global $db; include_once('db.php'); $needDb = TRUE;
				$data['table'][$rName] = sql_select(constant("DB_TABLE_PREFIX").$table,$where);
			}
		}
		$value = str_replace($rvalue[$r][0],"",$value);
	}
	$return = array(); $return['value'] = $value; $return['data'] = $data;
	return $return;
}
function getForm($formName,$data) {
	
	// inizialise variables
	$jsonPath = "forms/".$formName; $return = ""; $errormsg = "";
	if (!jsonExists($jsonPath)) { cmsConfigError("Choosen form is not available."); }
	$formData = getJson($jsonPath); $formFields = $formData['fields'];
	// echo("<pre>"); print_r($formData); echo("</pre><hr>"); 
	
	// if form is submitted
	if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_SESSION['form']) && $_SESSION['form'] == TRUE) {
		
		// inizialise variables
		$_SESSION['form'] = FALSE; $return = ""; $data['post'] = array();
		
		// add posted fields to data
		foreach(array_keys($formFields) as $f) { if (isset($_POST[$f])) { $data['post'][$f] = $_POST[$f]; } }
		
		// check field validities
		$error = array();
		foreach(array_keys($formFields) as $f) {
			$name = dynValues($formFields[$f]['name'],$data);
			$check = $formFields[$f]['check'];
			$isRegex = isValid($check,"/(\/.*?\/)/");
			if ($isRegex) { $check = "/(".substr($check,1,strlen($check)-2).")/"; }
			
			// TODO add all check types ...
			/*
			if (!$isRegex && isValid($check,"/(FALSE)/is") && isset($_POST[$f]) && isValid($_POST[$f],"/(TRUE)/is")) {
				$error[$f] = dynValues($formFields[$f]['error'],$data);
			}
			if (!$isRegex && isValid($check,"/(TRUE)/is") && !(isset($_POST[$f]) && isValid($_POST[$f],"/(TRUE)/is"))) {
				$error[$f] = dynValues($formFields[$f]['error'],$data);
			}
			*/
			
			if (isset($_POST[$f])) {
				$postData = $_POST[$f];
				if ($isRegex) {
					if (!isValid($postData,$check)) { $error[$f] = dynValues($formFields[$f]['error'],$data); }
				}
				
			}
		}
		
		// return errors
		if (is_array($error) && $error != array()) {
			$errormsg .= "<tr><td colspan=\"2\"><div class=\"errorMsg\">\n<div><b>ERRORS:</b></div>\n";
			foreach(array_keys($error) as $e) {
				$errormsg .= "<div>".dynValues($formFields[$e]['name'],$data).": ".$error[$e]."</div>\n";
			}
			$errormsg .= "</div></td></tr>\n";
		}
		
		// do actions
		if (is_array($error) && $error == array()) {
			
			// send mail
			$mail = isset($formData['mail']) ? $formData['mail'] : array();
			if (isset($mail['send']) && $mail['send'] == "1") {
				$info = getJson("info");
				$mailFrom = dynValues($mail['from'],$data);
				$mailReplyTo = dynValues($mail['reply'],$data);
				if ($mailReplyTo == "") { $mailReplyTo = $mailFrom; }
				$mailTo = dynValues($mail['to'],$data);
				$mailCc = dynValues($mail['cc'],$data);
				$mailBcc = dynValues($mail['bcc'],$data);
				$mailSubject = dynValues($mail['subject'],$data);
				$mailBody = dynValues($mail['body'],$data);
				$headers = 'Content-Type: text/plain; charset=UTF-8'."\r\n";
				$headers .= 'From: '.$mailFrom."\r\n";
				$headers .= 'Reply-To: '.$mailReplyTo."\r\n";
				$headers .= 'Cc: '.$mailCc."\r\n";
				$headers .= 'Bcc: '.$mailBcc."\r\n";
				$headers .= 'X-Mailer: '.$info['cms']['name'].' v'.$info['cms']['version'];
				// die(htmlentities($mailTo.",".$mailSubject.",".$mailBody.",".$headers));
				$isSent = mail($mailTo,$mailSubject,$mailBody,$headers);
				$msg = $isSent ? $mail['success'] : $mail['error'];
				$return .= "\n<div class=\"mailSentMessage\">".dynValues($msg,$data)."</div>";
			}
			
			// TODO write to db
			// ...
			
			return $return;
			
		}
	}
	
	// display form
	$_SESSION['form'] = TRUE; $formFieldsData = "";
	// echo("<pre>"); print_r($formFields); echo("</pre><hr>"); 
	foreach(array_keys($formFields) as $f) {
		$type = $formFields[$f]['type'];
		$name = dynValues($formFields[$f]['name'],$data);
		$value = isset($_POST[$f]) ? $_POST[$f] : "";
		$extraData = $type == "dropdown" ? $formFields[$f]['check'] : "";
		$formFieldsData .= "<tr><td>".$name."</td><td>".getFormField($type,$f,$value,$extraData)."</td></tr>\n";
	}
	$submitName = $formData['button']['submit']['name'];
	$submitName = strlen($submitName) > 0 ? $submitName : "Submit";
	$return = "
		<script language=\"javascript\">
			function ".$formName."OnSubmitJS() {
				".$formData['onSubmitJS']."
				//document.forms['".$formName."'].submit();
			}
		</script>
		<form name=\"".$formName."\" action=\"\" method=\"POST\" onsubmit=\"return ".$formName."OnSubmitJS()\">
			<table class=\"formTable\">
				<!--tr><th colspan=\"2\">".$formData['title']."</th></tr-->\n".$errormsg.$formFieldsData."
				<tr>
					<td>&nbsp;</td>
					<td class=\"submitFormButton\">
						<input type=\"submit\" name=\"submitFormButton\" value=\"".$submitName."\">
					</td>
				</tr>
			</table>
		</form>
	";
	//die($return);
	return $return;
	
}
function isFileAvailable($name) { return isFile("files/".$name); }
function insertAllowedPhpFunctions($string) {
	$array = array('preg_match','isFileAvailable','getUserFunction');
	foreach($array as $v) {
		//$oldString = $string;
		$string = preg_replace("/".$v."\s*\[(.*?)\]/is",$v."($1)",$string);
		//if ($oldString != $string) { echo($string."<br>"); }
	}
	return $string;
}

function dynForEach($value,$data) {
	$regex = "/\[foreach\]\s*\(\s*'(.*?)'\s*as\s*'(.*?)'\s*\)\s*{((?:(?:(?!\[foreach\]|}\s*\[\/foreach\]).)++|\[foreach\](?3)}\s*\[\/foreach\])*)}\s*\[\/foreach\]/is";
	preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER);
	foreach(array_keys($rvalue) as $r) {
		if (is_array($rvalue[$r]) && isset($rvalue[$r][1]) && isset($rvalue[$r][2]) && isset($rvalue[$r][3])) {
			$part = dynValues($rvalue[$r][1],$data); $split = split(":",$part); $items = $data;
			foreach(array_keys($split) as $s) { $items = is_array($items) && isset($items[$split[$s]]) ? $items[$split[$s]] : ""; }
			$newValue = ""; 
			if (is_array($items) && $items != array()) {
				$key = $rvalue[$r][2];
				foreach(array_keys($items) as $i) {
					$tmpNew = str_replace("{{".$key."}}",$i,$rvalue[$r][3]);
					$newArray = dynTables($tmpNew,$data); // $tmpNew = $newArray['value']; $data = $newArray['data']; 
					$newArray = dynIf($newArray['value'],$newArray['data']);
					$newArray = dynForEach($newArray['value'],$newArray['data']);
					$newValue .= $newArray['value'];
				}
			}
			$value = str_replace($rvalue[$r][0],$newValue,$value);
		}
	}
	$return = array(); $return['value'] = $value; $return['data'] = $data;
	return $return;
}
function dynIf($value,$data) {
	$regex = "/\[if\]\s*\((.*?)\)\s*{((?:(?:(?!\[if\]|}\s*\[\/if\]).)++|\[if\](?2)}\s*\[\/if\])*)}\s*\[\/if\]/is";
	preg_match_all($regex, $value, $rvalue, PREG_SET_ORDER);
	foreach(array_keys($rvalue) as $r) {
		$newValue = "";
		if (is_array($rvalue[$r]) && isset($rvalue[$r][1]) && isset($rvalue[$r][2])) {
			$bedingung = dynValues($rvalue[$r][1],$data);
			if (isValid($bedingung,"/([a-zA-Z0-9\s!&-=_+'|.,<>\*\[\]\/]*)/")) {
				$bedingung = insertAllowedPhpFunctions($bedingung);
				eval("\$isTrue = ".$bedingung.";");
				if ($isTrue === true) {
					$newArray = dynTables($rvalue[$r][2],$data);
					$newValue .= $newArray['value'];
				}
			}
		}
		$value = str_replace($rvalue[$r][0],$newValue,$value);
	}
	$return = array(); $return['value'] = $value; $return['data'] = $data;
	return $return;
}
function getDefaultPlaceholders() {
	$array = array();
	$array['info'] = getJson("info");
	$array['post'] = $_SERVER['REQUEST_METHOD'] == "POST" ? $_POST : array();
	$array['param'] = isset($_GET) && is_array($_GET) ? $_GET : array();
	$array['var'] = getJson("constant");
	$files = getDocuments();
	foreach(array_keys($files) as $x) {
		$path = constant("PROJECT_ROOT")."files/index.php?preview=".urlencode($files[$x]);
		$array['files'][$files[$x]]['path'] = $path;
		$array['files'][$files[$x]]['name'] = $files[$x];
	}
	return $array;
}
function getTemplate($page) {
	$array = getDefaultPlaceholders();
	$array['nav'] = getNavigationItems($page);
	$array['page'] = getPage($page);
	$array['page']['body'] = dynValues($array['page']['body'],$array);
	if (!jsonExists("design")) { cmsConfigError("No design available."); }
	$template = getJson("design");
	$template['title'] = dynValues($template['title'],$array);
	$template['meta_description'] = dynValues($array['page']['meta_description'],$array);
	$template['meta_keywords'] = dynValues($array['page']['meta_keywords'],$array);
	$template['body'] = dynValues($template['body'],$array);
	return $template;
}
// [  END  ] --- TEMPLATE FUNCTIONS ---

// ADMIN FUNCTIONS ---------------------------------------------------------------------------

// AUTHENTICATION FUNCTIONS
function isAdmin() { return isAuthenticated() && isset($_SESSION['isAdmin']) && $_SESSION['isAdmin'] === TRUE; }
function isModerator() { return isAdmin() || (isAuthenticated() && isset($_SESSION['isModerator']) && $_SESSION['isModerator'] === TRUE); }
function isMember() { return isAuthenticated(); }
function isVisitor() { return !isAuthenticated(); }
function getUserFunction($str) {
	$str = strtolower($str);
	if ($str == "admin" || $str == "administrator") { return isAdmin(); }
	if ($str == "mod" || $str == "moderator") { return isModerator(); }
	if ($str == "member") { return isMember(); }
	if ($str == "visitor") { return isVisitor(); }
	return false;
}

// JSON EDIT FUNCTIONS
function insertJsonItem($name,$array) { updateJsonItem($name,$array); }
function updateJsonItem($name,$array) { $json = getJson($name); $json = array_merge($json,$array); writeJson($name,$json); }
function removeJsonItem($name,$array) { $json = getJson($name); $json = array_diff_assoc($json,$array); writeJson($name,$json); } // does this work?
function updateJsonForm($name,$fix,$types,$isTree) {
	$isTree = $isTree === TRUE ? TRUE : FALSE;
	$json = getJson($name);
	$content = "<form method=\"post\" action=\"\" name=\"updateForm\"><table>";
	foreach(array_keys($json) as $x) {
		if ($isTree && is_array($json[$x])) {
			$content .= "<tr><th colspan=\"2\">".$x."</th></tr>";
			foreach(array_keys($json[$x]) as $y) {
				$field = !(isset($fix[$x]) && isset($fix[$x][$y])) ? getFormField($types[$x][$y],$x."[".$y."]",$json[$x][$y],"") : $json[$x][$y];
				$content .= "<tr><td>".$y.": </td><td>".$field."</td></tr>";
			}
		}
	}
	$content .= "<tr><td colspan=\"2\"><input type=\"submit\" name=\"updateForm\" value=\"Update\"></td></tr></table></form>";
}

function getFormField($type,$name,$value,$extraData) {
	$value = ereg_replace('"','&#34;',$value);
	if ($type == "hidden") { return "<input type=\"hidden\" class=\"hidden\" name=\"".$name."\" value=\"".$value."\">"; }
	if ($type == "password") { return "<input type=\"password\" class=\"password\" name=\"".$name."\" value=\"".$value."\">"; }
	if ($type == "textarea") { return "<textarea class=\"textarea\" name=\"".$name."\">".$value."</textarea>"; }
	if ($type == "checkbox") { return "<input type=\"checkbox\" class=\"checkbox\" name=\"".$name."\">"; }
	if ($type == "dropdown") {
		$options = split("//",$extraData); $optionText = "";
		foreach($options as $k => $v) {
			$id = htmlHexChars($v);
			$selected = $id == $value ? " selected=\"selected\"" : "";
			$optionText .= "<option value=\"".$id."\"".$selected.">".$v."</option>\n";
		}
		return "<select class=\"dropdown\" name=\"".$name."\">\n".$optionText."</select>";
	}
	if ($type == "file") { return "<input class=\"filefield\" type=\"file\" name=\"".$name."\">"; }
	return "<input type=\"text\" class=\"textfield\" name=\"".$name."\" value=\"".$value."\">";
}
function getFormFieldTypes() {
	return array(
		"text"=>"Text",
		"textarea"=>"Textarea",
		"checkbox"=>"Checkbox",
		"dropdown"=>"Dropdown",
		"file"=>"File"
	);
}

function getFormFieldTypeCheck($type,$value,$elementId) {
	if ($type === "checkbox") {
		$isCheckedText = isValid($value,"/(true)/is") ? " checked=\"checked\"" : "";
		return "
			<input type=\"checkbox\" id=\"field[".$elementId."][checkfield]\" name=\"data[fields][".$elementId."][check]\" value=\"true\"".$isCheckedText." class=\"check\">
			 Must be checked?
		";
	}
	if (isValid($value,"/(true)/is") || isValid($value,"/(false)/is")) { $value = ""; }
	$returnValue = "<input type=\"text\" id=\"field[".$elementId."][checkfield]\" name=\"data[fields][".$elementId."][check]\" value=\"".$value."\" style=\"width:130px;\">";
	if ($type === "dropdown") {
		$returnValue .= "<small> <a href=\"#\" onclick=\"alert('Double slash separated options of the dropdown instead of a check statement.\\nSyntax: Option1//Option2//OptionN');\">i</a></small>";
	}
	return $returnValue;
}
function getForms() { return getFiles(".json/forms/","json"); }
function getDocuments() {
	$path = constant("SERVER_PROJECT_ROOT")."files/"; $dir = dir($path);
	while ($entry = $dir->read()) {
		if (!is_dir($entry) && $entry > "" && $entry != "index.php" && $entry != "error_log") { $files[] = $entry; }
	}
	$dir->close(); $files = isset($files) ? $files : array(); sort($files); return $files;
}
function getFiles($folder,$ext) {
	$path = constant("SERVER_PROJECT_ROOT").$folder; $dir = dir($path);
	while ($entry = $dir->read()) {
		$isExt = $ext > "" ? substr($entry,strpos($entry,".")) == ".".$ext : TRUE;
		$entry = $isExt ? substr($entry,0,strpos( $entry,".")) : $entry;
		if ($isExt && !is_dir($entry) && $entry > "") { $files[] = $entry; }
	}
	$dir->close(); $files = isset($files) ? $files : array(); sort($files); return $files;
}
function isFile($name) {
	$file = constant("SERVER_PROJECT_ROOT").$name;
	return file_exists($file) && !is_dir($file);
}
function getFileType($name) { return mime_content_type(constant("SERVER_PROJECT_ROOT").$name); }
function getFileSize($name) { return filesize(constant("SERVER_PROJECT_ROOT").$name); }
function getFileSizeFormated($name) {
	$sizes = array(0=>'Byte',1=>'KB',2=>'MB',3=>'GB',4=>'TB');
	$fileSize = getFileSize($name); $value = $fileSize; $dim = $sizes[0];
	foreach(array_keys($sizes) as $s) { 
		$multiplier = pow(1024,$s);
		if ($fileSize/$multiplier>=1) { $value = $fileSize/$multiplier; $dim = $sizes[$s]; }
	}
	return $value." ".$dim;
}
function system_extension_mime_types() {
    $out = array();
    $file = fopen('/etc/mime.types', 'r');
    while(($line = fgets($file)) !== false) {
        $line = trim(preg_replace('/#.*/', '', $line)); if(!$line) { continue; }
        $parts = preg_split('/\s+/', $line); if(count($parts) == 1) { continue; }
        $type = array_shift($parts); foreach($parts as $part) { $out[$part] = $type; }
    }
    fclose($file); return $out;
}

function system_extension_mime_type($file) {
    static $types;
    if(!isset($types)) { $types = system_extension_mime_types(); }
    $ext = pathinfo($file, PATHINFO_EXTENSION);
    if(!$ext) { $ext = $file; } $ext = strtolower($ext);
    return isset($types[$ext]) ? $types[$ext] : null;
}

function system_mime_type_extensions() {
    $out = array(); $file = fopen('/etc/mime.types', 'r');
    while(($line = fgets($file)) !== false) {
        $line = trim(preg_replace('/#.*/', '', $line)); if(!$line) { continue; }
        $parts = preg_split('/\s+/', $line); if(count($parts) == 1) { continue; }
        $type = array_shift($parts);
        if(!isset($out[$type])) { $out[$type] = array_shift($parts); }
    }
    fclose($file); return $out;
}

function system_mime_type_extension($type) {
    static $exts; if (!isset($exts)) { $exts = system_mime_type_extensions(); }
    return isset($exts[$type]) ? $exts[$type] : null;
}
function getPages() { return getFiles(".json/pages/","json"); }

?>
